<template>
  <div class="role-management-container auto-height-container" :class="{ 'fullscreen-container': isFullscreen }">
    <vab-query-form>
      <vab-query-form-top-panel>
        <el-form ref="queryRef" inline label-width="70px" :model="queryForm" @submit.prevent>
          <el-form-item label="角色名称" prop="roleName">
            <el-input v-model="queryForm.roleName" clearable placeholder="请输入角色名称" style="width: 240px" @keyup.enter="handleQuery" />
          </el-form-item>
          <el-form-item v-if="!fold" label="权限字符" prop="roleKey">
            <el-input v-model="queryForm.roleKey" clearable placeholder="请输入权限字符" style="width: 240px" @keyup.enter="handleQuery" />
          </el-form-item>
          <el-form-item v-if="!fold" label="状态" prop="status">
            <el-select v-model="queryForm.status" clearable placeholder="角色状态" style="width: 240px">
              <el-option v-for="dict in sys_normal_disable" :key="dict.value" :label="dict.label" :value="dict.value" />
            </el-select>
          </el-form-item>
          <el-form-item v-if="!fold" label="创建时间" prop="dateRange" style="width: 308px">
            <el-date-picker
              v-model="queryForm.dateRange"
              end-placeholder="结束日期"
              range-separator="-"
              start-placeholder="开始日期"
              type="daterange"
              value-format="YYYY-MM-DD"
            />
          </el-form-item>
          <el-form-item>
            <el-button icon="Search" :loading="listLoading" native-type="submit" type="primary" @click="handleQuery">查询</el-button>
            <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            <el-button class="hidden-xs-only" text type="primary" @click="handleFold">
              <span v-if="fold">展开</span>
              <span v-else>合并</span>
              <vab-icon class="vab-dropdown" :class="{ 'vab-dropdown-active': fold }" icon="arrow-up-s-line" />
            </el-button>
          </el-form-item>
        </el-form>
      </vab-query-form-top-panel>
      <vab-query-form-left-panel>
        <el-button icon="Plus" type="primary" @click="handleAdd">添加</el-button>
        <el-button icon="Delete" type="danger" @click="handleDelete">删除</el-button>
        <el-button icon="Upload" plain type="warning" @click="handleExport">导出</el-button>
      </vab-query-form-left-panel>
      <vab-query-form-right-panel>
        <div class="custom-table-right-tools">
          <el-button @click="handleQuery">
            <vab-icon icon="refresh-line" />
          </el-button>
          <el-button @click="clickFullScreen">
            <vab-icon :icon="isFullscreen ? 'fullscreen-exit-fill' : 'fullscreen-fill'" />
          </el-button>
          <el-popover popper-class="custom-table-checkbox">
            <template #reference>
              <el-button>
                <vab-icon icon="settings-line" />
              </el-button>
            </template>
            <vab-draggable v-model="columns" :animation="600" target=".el-checkbox-group">
              <el-checkbox-group v-model="checkList">
                <el-checkbox
                  v-for="item in columns"
                  :key="item.label"
                  :disabled="item.disableCheck"
                  :label="item.label"
                  :value="item.label"
                >
                  {{ item.label }}
                </el-checkbox>
              </el-checkbox-group>
            </vab-draggable>
          </el-popover>
        </div>
      </vab-query-form-right-panel>
    </vab-query-form>

    <el-table ref="tableRef" v-loading="listLoading" border :data="list" @selection-change="setSelectRows">
      <el-table-column align="center" type="selection" width="50" />
      <el-table-column
        v-for="(item, index) in finallyColumns"
        :key="index"
        align="center"
        :fixed="item.fixed"
        :label="item.label"
        :min-width="item.minWidth || 160"
        :prop="item.prop"
        show-overflow-tooltip
        :sortable="item.sortable"
      >
        <template #default="scope">
          <span v-if="item.label === '状态'">
            <el-switch v-model="scope.row.status" active-value="0" inactive-value="1" @change="handleStatusChange(scope.row)" />
          </span>
          <span v-else>{{ scope.row[item.prop] }}</span>
        </template>
      </el-table-column>
      <el-table-column align="center" fixed="right" label="操作" width="360">
        <template #default="scope">
          <div v-if="scope.row.roleId !== 1" class="table-operation-button">
            <el-button icon="Edit" link type="primary" @click="handleUpdate(scope.row)">修改</el-button>
            <el-button icon="Delete" link type="primary" @click="handleDelete(scope.row)">删除</el-button>
            <el-button icon="CircleCheck" link type="primary" @click="handleDataScope(scope.row)">数据权限</el-button>
            <el-button icon="User" link type="primary" @click="handleAuthUser(scope.row)">分配用户</el-button>
          </div>
        </template>
      </el-table-column>
      <template #empty>
        <el-empty class="vab-data-empty" description="暂无数据" />
      </template>
    </el-table>
    <vab-pagination
      :current-page="queryForm.pageNum"
      :page-size="queryForm.pageSize"
      :total="total"
      @current-change="handleCurrentChange"
      @size-change="handleSizeChange"
    />
    <role-management-edit2 ref="editRef" @fetch-data="fetchData" />
    <role-management-auth ref="authRef" @fetch-data="fetchData" />
  </div>
</template>

<script lang="ts" setup>
import type { TableInstance } from 'element-plus'
import { VueDraggable as VabDraggable } from 'vue-draggable-plus'
import { changeRoleStatus, doDelete, getList } from '/@/api/roleManagement'

defineOptions({
  name: 'RoleManagement',
})

const router = useRouter()
const { proxy } = getCurrentInstance() as any
const { sys_normal_disable } = proxy.useDict('sys_normal_disable')

const { exit, enter, isFullscreen: _isFullscreen } = useFullscreen()

const isFullscreen = ref<boolean>(false)
const fold = ref<boolean>(true)
const tableRef = ref<TableInstance>()
const editRef = ref<any>(null)
const authRef = ref<any>(null)
const list = ref<any>([])
const listLoading = ref<boolean>(true)

const total = ref<number>(0)
const selectRows = ref<any>([])
const checkList = ref<any>([])
const queryForm = reactive<any>({
  pageNum: 1,
  pageSize: 10,
  roleName: undefined,
  roleKey: undefined,
  status: undefined,
  dateRange: [],
})

const columns = ref<any>([
  { label: '角色编号', prop: 'roleId', minWidth: 120, checked: true },
  { label: '角色名称', prop: 'roleName', minWidth: 150, checked: true },
  { label: '权限字符', prop: 'roleKey', minWidth: 150, checked: true },
  { label: '显示顺序', prop: 'roleSort', minWidth: 100, checked: true },
  { label: '状态', prop: 'status', minWidth: 120, checked: true },
  { label: '创建时间', prop: 'createTime', minWidth: 160, checked: true },
])
const finallyColumns = computed(() => columns.value.filter((item: any) => checkList.value.includes(item.label)))

watch(
  _isFullscreen,
  () => {
    if (_isFullscreen.value) isFullscreen.value = true
    else isFullscreen.value = false
  },
  { immediate: true }
)

onActivated(() => {
  tableRef.value?.doLayout()
})

onBeforeMount(() => {
  columns.value.forEach((item: any) => {
    if (item.checked) checkList.value.push(item.label)
  })
  fetchData()
})

/** 点击全屏 */
const clickFullScreen = () => {
  isFullscreen.value = !isFullscreen.value
  isFullscreen.value ? enter() : exit()
}

/** 搜索条件折叠 */
const handleFold = () => {
  fold.value = !fold.value
}

/** 查询角色列表 */
const fetchData = async () => {
  listLoading.value = true
  const pp = Object.assign({}, proxy.addDateRange(queryForm, queryForm.dateRange))
  delete pp.dateRange
  const { rows, total: _total } = (await getList(pp)) as any
  list.value = rows
  total.value = _total
  listLoading.value = false
}

/** 搜索按钮操作 */
function handleQuery() {
  queryForm.pageNum = 1
  fetchData()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm('queryRef')
  handleQuery()
}

const handleSizeChange = (value: number) => {
  queryForm.pageNum = 1
  queryForm.pageSize = value
  fetchData()
}

const handleCurrentChange = (value: number) => {
  queryForm.pageNum = value
  fetchData()
}

const setSelectRows = (value: string) => {
  selectRows.value = value
}

/** 角色状态修改  */
function handleStatusChange(row: any) {
  const text = row.status === '0' ? '启用' : '停用'
  $baseConfirm(
    `确认要${text}“${row.roleName}”角色吗?`,
    null,
    async () => {
      await changeRoleStatus(row.roleId, row.status)
      $baseMessage(`${text}成功`, 'success', 'hey')
    },
    () => {
      row.status = row.status === '0' ? '1' : '0'
    }
  )
}

/** 新增按钮操作 */
const handleAdd = () => {
  editRef.value.showEdit()
}

/** 修改按钮操作 */
function handleUpdate(row: any) {
  editRef.value.showEdit(row)
}

/** 删除按钮操作 */
const handleDelete = (row: any = {}) => {
  if (row.roleId) {
    $baseConfirm(`您确定要删除角色名称为“${row.roleName}”的数据项吗`, null, async () => {
      const { msg }: any = await doDelete(row.roleId)
      $baseMessage(msg, 'success', 'hey')
      await fetchData()
    })
  } else {
    if (selectRows.value.length > 0) {
      const ids = selectRows.value.map((item: { roleId: any }) => item.roleId)
      $baseConfirm('您确定要删除选中项吗', null, async () => {
        const { msg }: any = await doDelete(ids)
        $baseMessage(msg, 'success', 'hey')
        await fetchData()
      })
    } else {
      $baseMessage('您未选中任何行', 'warning', 'hey')
    }
  }
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download(
    'system/role/export',
    {
      ...queryForm,
    },
    `role_${Date.now()}.xlsx`
  )
}

/** 分配数据权限操作 */
function handleDataScope(row: any) {
  authRef.value.showEdit(row)
}

/** 分配用户 */
function handleAuthUser(row: any) {
  router.push(`/system/roleManagement/authUser/${row.roleId}`)
}
</script>
